#include <sdktools_functions>
#include <cstrike>
#include <vip>

#pragma semicolon 1

public Plugin:myinfo = 
{
	name	= "VIP [Drop Any Weapon]",
	author	= "wS",
	version = "1.2.4"
};

#define ITEM_NAME "drop"

new bool:g_bAccess[MAXPLAYERS + 1];
new Float:g_fLastFireTime[MAXPLAYERS + 1];
new bool:g_bSpawnWithKnife;

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE)) {
		SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	}
	
	//
	new Handle:hCvar  = CreateConVar("daw_spawn_with_knife", "1");
	g_bSpawnWithKnife = GetConVarBool(hCvar);
	HookConVarChange(hCvar, CvarChanged);
	//
	
	HookEvent("weapon_fire", weapon_fire);
	VIP_HookEvent(VE_Spawn, OnClientSpawn);
	
	AddCommandListener(DropHook, "drop");
}

public CvarChanged(Handle:hCvar, const String:OldValue[], const String:NewValue[])
{
	g_bSpawnWithKnife = StringToInt(NewValue) == 1;
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	SetStatus(client, false);
}

static SetStatus(client, bool:enabled)
{
	g_bAccess[client] = enabled;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////
	
public Action:DropHook(client, const String:command[], args)
{
	new weapon;
	
	if (	client > 0
		&& 	client <= MaxClients
		&& 	g_bAccess[client]
		&& 	(GetGameTime() - g_fLastFireTime[client]) > 1.0
		&&	(weapon = GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon")) > 0
		&&	GetEntPropEnt(weapon, Prop_Send, "m_hOwnerEntity") == client
	) {
		CS_DropWeapon(client, weapon, true, false);
		return Plugin_Handled;
	}
	
	return Plugin_Continue;
}

public weapon_fire(Handle:event, const String:name[], bool:silent)
{
	//       
	g_fLastFireTime[GetClientOfUserId(GetEventInt(event, "userid"))] = GetGameTime();
}

public OnClientSpawn(client, team)
{
	if (g_bSpawnWithKnife && GetPlayerWeaponSlot(client, 2) < 1) {
		GivePlayerItem(client, "weapon_knife");
	}
}

public OnClientDisconnect(client)
{
	g_bAccess[client] = false;
	g_fLastFireTime[client] = 0.0;
}